*** Redsys Gateway Change Log ***

2024.03.14 - version 25.0.1

* NEW: Ability to hide Chekout logos.
* UPDATE: Declared compatibility with WooCommewrce 8.7
* UPDATE: Declared compatibility with WordPress 6.5
* FIX: Under some circumstances, an error occurs when editing some pages.

2024.03.14 - version 25.0.0

* NEW: Redsys redirection added to Checkout Block
* NEW: Google Pay redirection added to Checkout Block
* UPDATE: Updated print_overlay_image().
* UPDATE: Updated spinner.
* UPDATE: The option to hide by country has been removed from Redsys redirection and InSite. The limitation that apparently existed has been overcome worldwide.
* UPDATE: All checkout payments methods logos are customizable.
* FIX: Many notices.
* FIX: Text domain in email strings (credit Card expiration & deletion).
* FIX: Paygold was always displayed in the checkout block regardless of the settings.

2024.02.21 - version 24.3.4

* UPDATE: Some URLS to woo.com.
* FIX: Fatal error in thank you page introduced in v24.3.3

2024.02.21 - version 24.3.3

* UPDATE: Removed deprecatd CSS.
* UPDATE: If the server takes too long to process the order, Apple Pay will report an error even if the payment is made correctly.
* UPDATE: A query that used to be performed everywhere is now only executed on the front-end when necessary.
* FIX: Undefined array key "wc_actions" class-redsys-advanced-setings.php
* FIX: Many lines Undefined $order_id with Redsys redirection.
* FIX: Under some circumstances, it redirects to Redsys even though the modal is active.
* FIX: If SNI compatibility is enabled, it produces a security error in the redirection to Redsys.

2024.02.07 - version 24.3.2

* FIX: No subscription tokens were being saved.

2024.02.05 - version 24.3.1

* FIX: Fixed an issue where an error would occur if a purchase was made through Bizum in the checkoput while simultaneously creating an account.
* FIX: Fatal error when Woo Subscriptions is not installed.

2024.02.04 - version 24.3.0

* UPDATE: More sanitization.
* UPDATE: Updated some URLs.
* UPDATE: Now, there is no charge when changing the method in a subscription in Woo Subscriptions.
* FIX: Notice _billing_first_name & _billing_last_name wc_doing_it_wrong.
* FIX: Fatal error in Site Health when SOAP cannot connect to Redsys addresses.
* FIX: PHP Warning:  Attempt to read property "total" on null (Paygold).
* FIX: Fixed an issue where an error would occur if a purchase was made through InSite while simultaneously creating an account.
* FIX: The subscriptions through the one-click payment button were set as manual renewal.
* FIX: The script for the checkout button was showing up in all the footers of the site.
* FIX: In some cases, the Redsys order number was not being saved in the order.
* FIX: Fixed an issue with the TZ field on some servers.
* FIX: Now the payment method can be switched without incurring an extra charge.


2023.12.18 - version 24.2.1

* UPDATE: Copyrigth date.
* UPDATE: Added more logs.
* UPDATE: Temporal disabled Banner Live.
* FIX: Some notices.
* FIX: Undefined variable $all_redsys_data

2023.11.26 - version 24.2.0

* NEW: Pay with one click using a button for non-virtual products (Shipping).
* NEW: Hooks redsys_before_shipping_dropdown_product, redsys_after_shipping_dropdown_product, redsys_before_buy_now_button_product, and redsys_after_buy_now_button_product.
* NEW: Now you can select if the order is marked as processing or complete when confirming a preauthorization. Go to WooCommerce > Settings > Redsys Advanced > General.
* NEW: Filter to accept shipping methods not registered in WooCommerce > redsys_accepted_shipping_methods.
* UPDATE: Improved Subscriptions. Added descriptions and customer names.
* UPDATE: Increased the duration of redsys_signature_transient from 600 to 3600 seconds.
* UPDATE: Renamed the default title for GPay from 'GPay' to 'Google Pay'.
* FIX: Numerous notices.

2023.11.06 - version 24.1.0

* NEW: Virtual Subscriptions products Pay with one clic button compatibility.
* UPDATED: Temporary removal of the specific code for WordPress Multisite to perform a refactoring that does not affect page load.
* FIX: Fixed two save terminal numbers with InSite when the order is paid.

2023.10.30 - version 24.0.1

* FIX: Arrive to thank you page when modal is not active with redirection.

2023.10.27 - version 24.0.0

* NEW: Pay with one click from products. Only virtual products. It will be improved in next versions.
* NEW: Now the plugin check for errors 172, 173 and 174. Mandatory by Visa and MasterCard. With Errors 172 & 173, credir card are removed from WooCommerce.
* UPDATE: Improved Redsys modal.
* UPDATE: Improved Redsys methods reload.
* FIX: Typo error in x-www-form-urlencoded

2023.10.26 - version 23.0.3

* FIX: Problem with Yith Subscriptions >3.0 caused by woocommerce_order_button_text hook.

2023.10.20 - version 23.0.2

* FIX: Something happened between October 18-19 that caused some SOAP servers to stop functioning correctly, regardless of the plugin version. I have applied a fix provided by the Redsys developer department (which I greatly appreciate) and it worked, so this version incorporates it. It's a mandatory update if you are experiencing problems with SOAP.

2023.10.14 - version 23.0.1

* UPDATE: Added more text sanitization.
* UPDATE: Enhance jQuery checkout reload.
* UPDATE: GET price from checkout refactoring.
* FIX: Removed debug log that allways is saved.

2023.10.13 - version 23.0.0

* NEW: Added Apple Pay
* NEW: Added filter redsys_allow_preauth.
* NEW: Added filter redsys_allow_token_r.
* UPDATE: Get price from rest API.
* UPDATE: If in "Bizum in the Checkout" the customer does not add the +34 prefix, it will now be added automatically. In a percentage that is close to 100%, the numbers will be Spanish, so this should help address the oversight of many customers.

2023.09.19 - version 22.2.1

* FIX: Fixed the terminal saving issue in one of the processes. It was causing issues with returns through InSite.
* FIX: Fixed an issue with sending COF_TYPE in one of the processes with InSite.

2023.09.05 - version 22.2.0

* NEW: Preauthorizations with InSite

2023.08.19 - version 22.1.1

* FIX: InSite compatibility with SUMO Subscriptions.
* FIX: New Subscripiton paid with Subscription Token.
* UPDATE: String in General settings, Redsys Advanced.

2023.08.18 - version 22.1.0

* NEW: Added compatibility to Redsys redirecttion & InSite with SUMO Subscriptions.
* NEW: Send an email when the credit card is about to expire.
* NEW: Remove expired credit cards.
* NEW: Send an email when the credit card is deleted because it has expired.
* UPDATE: Refactoring Redsys admin Tabs.
* UPDATE: Some JavaScript variables have been customized using the name "Redsys" to prevent conflicts with other plugins.
* UPDATE: Removed code that was no longer necessary and that caused a subscription renewal issue on some servers.
* FIX: SVG Image QR Codes.

2023.07.16 - version 22.0.0

* NEW: Google Pay in Checkout.
* NEW: Added pay.google.com to dns-prefetch
* NEW: Added GPay logo to Payments methods block.
* UPDATE: Updated GPay redirection Strings.
* UPDATE: Updated GPay redirection Logo.
* FIX: Undefined variable $redsys.
* FIX: Attempt to read property "debug" on null.
* FIX: Undefined property: WC_Gateway_Bizum_Checkout_Redsys::$orderdo.

2023.07.12 - version 21.2.1

* FIX: Fix enctype in creq form (InSite).

2023.06.30 - version 21.2.0

* NEW: Google Pay redirection.
* UPDATE: Updated all endpoint menssages when are visited.
* UPDATE: Added subscriptions into checkout modal.
* FIX: Credit card v2.1 with InSIte.

2023.06.19 - version 21.1.0

* NEW: Bizum in the Checkout.
* UPDATE: InSite was not redirecting to the checkout under certain error flows.
* UPDATE: Translated many strings.

2023.06.18 - version 21.0.2

* UPDATE: Declared compatibility with WooCommerce 7.8.
* FIX: Fixed refunds with InSite.
* FIX: Fixed TRA with InSite.

2023.06.15 - version 21.0.1

* FIX: Fixed a problem with Italy. This update is mandatory!

2023.05.30 - version 21.0.0

* NEW: Added catalan front translation for InSite.
* NEW: Added galego front translation for InSite.
* NEW: Added euskera front translation for InSite.
* NEW: Added Gutenberg Block for Credit Card Image.
* NEW: Added Checkout Block for Bizum.
* NEW: Added Checkout Block for PayGold.
* NEW: Added Checkout Block for MasterPass.
* NEW: Added Checkout Block for Redsys Bank Transfer.
* NEW: Added Checkout Block for Redsys Direct Debit.
* FIX: InSite tokenization. Now only save the token when it is indicated to save the card at checkout.

2023.05.14 - version 20.4.0

* NEW: The InSite form is now always displayed. Filling in some fields is no longer necessary. Thanks to the new API, there's no need to wait anymore.
* NEW: The website URL is now displayed on the Thank You page (new Redsys requirement).
* UPDATE: Improved HPOS metadata.
* UPDATE: Enhanced InSite for v1 credit cards.
* UPDATE: Refined states in EMV3DS.
* UPDATE: Declared compatibility with WooCommerce 7.7.
* UPDATE: Removed old code.
* UPDATE: Improved state in EMV3DS.
* UPDATE: Improved Phone (CC) in EMV3DS.
* UPDATE: Updated browserColorDepth in EMV3DS.
* FIX: Fixed a comma in the global class. On some servers, this comma can cause a fatal error.
* FIX: Corrected a string in InSite.
* FIX: Now, Yith Subscriptions with InSite work again.
* FIX: Resolved notice in Site Health Class.

2023.04.02 - version 20.3.0

* UPDATE: Improved InSite with authenticators.
* UPDATE: Added more non-english caracters to sanitization.
* UPDATE: Now if the customer language is not in plugin array, the plugin use English language.
* UPDATE: Improved redirection with modal. Now the modal is closed when the customer press cancel bitton in Redsys.
* FIX: Fixed an error when Pay with 1click is not active in InSite.
* FIX: Fixed many Notices and some Warnings.

2023.03.01 - version 20.2.1

* FIX: Temp disabled function for hide Bizum. I have to check what changed in WooCommerce.

2023.02.27 - version 20.2.0

* NEW: New modal options for Redsys redirection.
* NEW: Added InSite API V3.
* NEW: New option for disable the action by the plugin of mark as paid the renewal subscriptions in Redirections and InSite.
* NEW: Declared compatibility with WooCommerce 7.4
* UPDATE: Redesign of InSite Separate fields (Stripe Clone).
* UPDATE: Updated function create_add_payment_method_number() for delete WP cache for "number_ad_paymnt_mehod" before get the option.
* UPDATE: Updated function create_checkout_insite_number() for delete WP cache for "number_insite_checkout" before get the option.
* FIX: Fixed many Notices and some Warnings.
* FIX: In "The Call 5" with InSite, the customer name and last name was not send to Redsys.
* FIX: Show tokens in Admin user Edit screen.

2023.02.09 - version 20.1.0

* NEW: a dedicated logo for PayGold and the ability to custimize it from admin settings.
* NEW: Now you can see the send Link for add credit card in Edit User Screen.
* NEW: Declared compatibility with WooCommerce 7.4.
* NEW: Declared compatibility with WordPress 6.2.
* UPDATE: Now InSite Description allow HTML.
* UPDATE: Recovered orders now works redirecting to Redsys if it is "redsys" Order.
* FIX: Fixed a duplicated "mark as paid" with Subscription renewal. This was because the Redsys plugin and WooCommerce Subscriptions both marked the order as paid.
* FIX: Fixed Reload checkout if the customer is not identificated and an account is created.

2023.01.25 - version 20.0.3

* FIX: Fixed an error with Pay button from My account when WooCommerce Subscriptions is not installed.

2023.01.19 - version 20.0.2

* FIX: Fixed a function that in some servers can cause a fatal error.

2023.01.18 - version 20.0.1

* FIX: Now the QR Code metabox only is shown in products edit screen if QR Codes is active.

2023.01.18 - version 20.0.0

* NEW: Added QR Codes (starting with Products).
* NEW: New option/check for preautorize all Orders in Redsys redirection.
* NEW: Added "redsys_kses_descripcion" for modify allowed HTML in Redsys redirection checkout description.
* DELETE: Specific Gateway for Preauthorizations, now use Redsys redirection (by Jose Conti).
* UPDATE: Improved Subscriptions in Card.
* UPDATE: Now Description allow HTML.
* FIX: Fixed an error when the customer pay with the WooCommerce Pay Link.
* FIX: Fixed text "Add a credit card for Pay with 1click" in "Add payment method" Screen.
* FIX: Fixed error in Bizum saving a meta value.

2023.01.13 - version 19.1.0

* NEW: Added Scheduled Action to delete expired transients.
* NEW: Added Scheduled Action to delete information related to removed tokens.
* NEW: Added new filter for Bulk Refunds "redsys_refund_filter".
* NEW: Added Redsys integration by iframe with Redsys redirection.
* NEW: Removed support for PHP 5.x
* NEW: Declared compatibility with WordPress 6.2
* NEW: Declared compatibility with WooCommerce 7.3
* NEW: New Constant "REDSYS_LICENSE_SITE_ID" for WordPress Multisite. Default "1".
* UPDATE: Checking Redsys Licence in WordPress Multisite.
* FIX: Two HPOS metas.
* FIX: Customer name send to Bizum.
* FIX: Removed a log code that echo a $_POST.
* FIX: Fixed test mode in MasterPass.

2022.12.23 - version 19.0.1

* FIX: Fixed Typo in Global function get_last_four()
* FIX: Fixed pay with 1click in redirection.

2022.12.19 - version 19.0.0

* NEW: Requieres WC >= 7.0
* NEW: Declared compatibility with WordPress 6.1
* NEW: Declared compatibility with WooCommerce 7.1
* NEW: (BETA) Added compatibility with HPOS.
* NEW: Now you can send a link to add a credit card from the user edit screen.
* NEW: Now you can select in Edit product > Redsys that a product has to be preauthorized.
* New: Now hide all methods not compatibles with Preauthotizations when in Edit product > Redsys is preauthorize active.
* New: New options at Redsys redirections and Redsys in the Checkout. Now you can select if the method is shown for all countries or related to Banking redsys Network.
* NEW: New filter for adding a custom message when a link for adding a credit card is sent: "redsys_mail_add_token"
* NEW: New filter for adding a custom message in the Checkout when a credit card is needed: "redsys_text_get_token"
* NEW: New filter for modifying description in Redsys website: "redsys_product_description"
* NEW: New filter for modifying text add cards in My Account > Payment Method  > Payment Method: "text_add_card_my_account"
* NEW: New action "redsys_payment_fields"
* NEW: New action "save_field_update_order_meta"
* NEW: New action "redsys_post_payment_complete"
* NEW: New action "bizum_post_payment_complete"
* NEW: New action "directdeb_post_payment_complete"
* NEW: New action "insite_post_payment_complete"
* NEW: New action "masterpass_post_payment_complete"
* NEW: New action "paygold_post_payment_complete"
* NEW: New action "redsys_post_payment_error"
* NEW: New action "bizum_post_payment_error"
* NEW: New action "directdeb_post_payment_error"
* NEW: New action "insite_post_payment_error"
* NEW: New action "masterpass_post_payment_error"
* NEW: New action "paygold_post_payment_error"
* NEW: Declared compatibility with WooCommerce 7.1.
* NEW: Declared compatibility with WordPress 6.1.
* NEW: Now, PSD2 & Global Classes generate its own logs when WP_DEBUG is set to true.
* NEW: Renamed WooRedsysAPIWS to WooRedsysAPIWs to avoid Classes Conflict.
* NEW: Renamed RedsysAPI to WooRedsysAPI to avoid Classes Conflict.
* NEW: If WP_DEBUG is defined as true, you will get more logs from different special classes and files.
* NEW: Added new Redsys Transactions response.
* NEW: Deprecation global function get_post_edit_url(), update it to get_order_edit_url().
* UPDATE: InSite now accepts Fallback authentication.
* UPDATE: InSite now accepts non-PSD2 Credit Cards.
* UPDATE: Now Redsys get a subscription token in Edit products Redsys tab works with all product types.
* UPDATE: Now hide all methods incompatible with the Subscriptions token when Edit product > Redsys gets the token active.
* UPDATE: Updated string "Order Payment refunded" to "Order Payment refunded by Redsys".
* UPDATE: Added "failed" Status as not paid.
* UPDATE: The redirection to Redsys has been updated from a custom URL to Redsys WooCommerce Endpoint. I have made this change so that plugins that break custom endpoints take care of the endpoint gateways generated by WooCommerce.
* UPDATE: Transaction Errors are now shown in Checkout.
* FIX: Now, the customer Name is sent again with Bizum.
* FIX: Fixed a fatal error when there is a pay error.
* FIX: Fixed a fatal error sending an error email with Preauthorizations.
* FIX: Now the Tokens fields are not shown in Network > User Edit.
* FIX: It now saves the Redsys order number in some processes that previously did not.
* FIX: Fixed HTML code that breaks the Add Method Page when there is more than one method.
* FIX: Fixed a notice about permission_callback endpoint API needing definition __return_true.
* FIX: Fixed email sent to customers when there is a credit card payment.
* FIX: Now the customer name is sent to Redsys with Subscriptions renew.
* FIX: Renamed class Plugin_List_Links() to Plugin_List_Links_Redsys_Premium() because the new version of the official Redsys plugin has copied my plugin code to their plugin and causes a fatal error when both are active.

2022.03.24 - version 18.1.1

* UPDATE: Improved compatibility with the generated payment link by WooCommerce (Redsys redirection).
* FIX: Fixed an error with Redsys in the Checkout (InSite). Using $this when not in object context.

2022.03.21 - version 18.1.0

* NEW: Added a custom status for Redsys Orders. Pending Redsys Payment
* UPDATE: Added more push notifications.
* UPDATE: Now Orders can be flagged as paid even though were marked as Cancelled.
* FIX: The Errors check in Redsys Push Notifications now remain checked.
* FIX: Added "cancelled" as not paid statuses.

2022.03.14 - version 18.0.0

* NEW: Mobile Push Notification. Needs Catapush service.
* NEW: Now, an Order Subscription Note is added if the Credit Card doesn't exist or expired.
* NEW: Errors are added to Order Notes.
* NEW: New global function push().
* NEW: New global function get_post_edit_url().
* NEW: New global function get_last_four().
* NEW: Declared compatibility with WooCommerce 6.3.
* NEW: Now you can customize an email for notifications.
* UPDATE: Now is only allowed to add a Subscription credit card in My Account > Add payment method when 1clic is disabled.
* UPDATE: The SCA LWV is now an option in Redsys redirection && Redsys in ths Checkout. You need to ask Redsys to enable it.
* UPDATE: Now DS_MERCHANT_GROUP is sent with PayGold.
* UPDATE: Removed several logs that were annoying and not useful.
* UPDATE: Now the plugin check Ds_Card_Number & Ds_CardNumber. Redsys is sending both fields.
* UPDATE: Removed many pre PDS2 deprecated code.
* UPDATE: Updated some strings.
* FIX: InSite DS_MERCHANT_PRODUCTDESCRIPTION Works again.
* FIX: If a subscription is not renewed, WooCommerce Subscriptions will retry it.
* FIX: Refunds with InSite, works again.
* FIX: Removed InSite debug line in checkout.
* FIX: Removed deprecated code on Global Class $get_token.

2022.02.19 - version 17.1.1

* UPDATE: More information about token are shown in user edit.
* FIX: Two notices ($debug & $testmode).
* FIX: fallback compatibility with tokens.
* FIX: Add Payment Method from My Account.

2022.02.15 - version 17.1.0

* NEW: Now, you can send a Pay Gold link to all your users through the Bulk Actions of the user list to request a token for Subscriptions or payment with one click. Merchant Group is recommended.
* NEW: Added new Live Banner for notices.
* NEW: Added SOLES Peruanos currency.
* NEW: Addded compatibility with "All Products for WooCommerce Subscriptions".
* UPDATE: Removed WC_Loggger() from Global Class.
* UPDATE: In some installations, all products Subscriptions are not correctly detected. Now it is recognized.
* UPDATE: Now, you can send a payment link from WooCommerce to your customer, and your user is allowed to pay.
* UPDATE: Now, the plugin Check if the Order is already marked as paid before mark it as paid (again).
* FIX: Fixed an issue where an error was displayed if the user had a subscription token and tried to purchase a subscription of cost 0. 
* FIX: Some HTML tweaks in checkout.
* FIX: Now only show test gateway to selected users works again.
* FIX: Fixed some translations.
* FIX: Fixed a screen message in the InSite endpoint.
* FIX: removed a deprecated log that was causing a notice.
* FIX: removed deprecated fields from Sequential Invoice Number.
* FIX: fixed an InSite settings description field. It had the wrong description.
* FIX: Updated a Redsys field. Now the Credit Card Number is again saved.

2021.12.04 - version 17.0.3

* NEW: New option for move Terms checkout check above Gateways. Set in Redsys in the Checkout settings.
* FIX: Fixed some translations strings.

2021.11.11 - version 17.0.2

* UPDATE: When no user data are collected in the checkout, now is not sent as 3DS to Redsys.
* FIX: Now, when in Redsys redirection is selected using a new credit card and is a subscription, the customer is redirected to Redsys.
* FIX: There were wrong quotes.

2021.11.07 - version 17.0.1

* UPDATE: CSS in Redsys redirection checkout.
* FIX: Some notices.
* FIX: Version 17.0.0 has some problems with some servers with mod_security active. This version fixes all these problems.
* FIX: There was one PHP open tag, and this make problems on some servers.

2021.10.25 - version 17.0.0

* NEW: Now you can add a subfix.
* NEW: Declared compatibility with WooCommerce 5.9.
* NEW: Now the user can select a credit card or if he want to save a credit card in the checkout with Redsys redirection.
* NEW: Now you can send a Pay Gold Link to a customer for get a Subscription or 1clic Token. WooCommerce > Pay Gold Tools
* UPDATE: Now the plugin recognize the 2.1 & 2.2 credit cards.
* FIX: Now Payment Methods in My Account is shown With Redsys in the checkout.

2021.09.13 - version 16.1.1

* FIX: Fixed Warning in admin WC_Helper_Options 

2021.09.12 - version 16.1.0

* NEW: Now you can select Order Number format in Redsys redirection.
* NEW: Multisite deep compatibility. Now you have specific options for WordPress Multisite.
* NEW: You can see Redsys new guides and posts in WordPress Dashboard.
* NEW: Now you can add a custom logo for InSite.
* NEW: Now you can select between InSite (Redsys in the checkout) Independent Elements credit card form (default) or Integrated credit card form.
* UPDATE: String translation.
* UPDATE: Webservice.
* UPDATE: Now Paygold check for SOAP and SimpleXML.
* FIX: Removed a debug line in Redsys redirection screen settings.
* FIX: Now you can make a InSite refund.
* FIX: Now you can make a Subscription refund.
* FIX: Fixed an error telling to subscriptions that is a Fail order.
* FIX: Fixed a problem with payments with free subscriptions and with users with token.
* FIX: Fixed a problem in My Account > Payment Methods, where in some cases when there are not Redsys Tokens an error are screened.

2021.07.05 - version 16.0.1

* FIX: Fixed a problem with PayGold, the metabox was trying to load in other post types
* Updated: Updated all new translations

2021.07.04 - version 16.0.0

* NEW: Added PayGold Method
* NEW: Added new Bizum Filter. Now you can use infinite terminals with bizum_modify_data_to_send filter.
* NEW: Added all new Redsys errors to the plugins. Now recognizes more that 1.370 Redsys errors.

2021.06.21 - version 15.2.2

* FIX: In v15.2.1 I introduced a bug that prevented the return of orders prior to v15.2.1. 

2021.06.21 - version 15.2.1

* UPDATE: Improved filter redsys_modify_data_to_send. Now FUC is saved as meta, so refunds work correctly.
* FIX: Removed a Redsys Method not ready. Sorry, I forget to comment a line, and a not ready Redsys method was loaded on the WooCommerce Payment settings page.

2021.06.19 - version 15.2.0

* NEW: Now InSite is hidden in the Add Method page.
* NEW: Now you can activate Redsys redirection only in Add Method page.
* FIX: Fixed an issue where data could not be copied to the admin profile page.
* FIX: Fixed the order "1 billion".

2021.06.09 - version 15.1.2

* Fixed: Problem with Bizum.

2021.06.01 - version 15.1.1

* Fixed: Replacing a jQuery that I had accidentally deleted.

2021.06.01 - version 15.1.0

* NEW: Added Pay with 1click to Redsys in Checkout (by Jose Conti) - InSite
* NEW: Added an API function that can be called by passing the $order_id and in this way charge it WCRed()->collect_invoice_by_id( $order_id )
* NEW: Added a column in the Payments method for know is the token is for Pay with 1click or Subscriptions.
* NEW: Now you can you tell to InSite the checkout field billing_first_name if it is customized.
* NEW: Now InSite is reloaded if the Checkout field billing_first_name is updated.
* NEW: Now you can set a limit cart amount for use Bizum.
* NEW: Added dns-prefetch for InSite JS.
* NEW: Added InSite compatibility with SNI.
* NEW: Now, you can hide a payment method in the checkout when it is in test mode and select who can view it.
* UPDATE: Improved Site Health.
* UPDATE: Now Checkout is only reloaded when there is an error when InSite is active.
* UPDATE: All JS plugin files minified.
* UPDATE: Now a finger pointer is show when cursor is over InSite Pay button.
* UPDATED: Updated the email send to admin when Ds_Card_Number is not send by Redsys.
* FIX: TRA and LWV in standard payment.
* FIX: Fixed a Bizum payment problem over some servers configuration.
* FIX: Fixed a problem with flush rules (Thanks to @frantorres)
* FIX: Fixed some Undefined variables & properties.

2021.03.26 - version 15.0.3

* NEW: Added more customizations to Redsys in Checkout (by Jose Conti) - InSite.
* NEW: Updated title and description of Redsys in Checkout (by Jose Conti) - InSite
* FIX: Fixed 4 PHP Warnings.
* FIX: Fixed Fixed a problem with card with amounts over 30€

2021.03.03 - version 15.0.2

* REFACTORING: InSite Refactoring to charge after abandoning the checkout page.
* NEW: Added WooCommerce Errors to checkout about credit card payments.

2021.02.23 - version 15.0.0

* NEW: Refactoring InSite
* NEW: Added Credit card form on the checkout page
* NEW: TRA for InSite
* NEW: Added SHA256 test settings to InSite
* NEW: Added User test to InSite
* NEW: Added Redsys order number meta in every Redsys plugin edit Order.
* FIX: KO Return from Redsys when is Add Method.
* FIX: Now PSD2 use numeric code indeed Alpha-2

2021.01.28 - version 14.0.3

* FIX: Workaround with the Ds_ExpiryDate because Redsys stop to send it by default.
* FIX: Fixed Redsys (by Jose Conti) checkout description.

2021.01.18 - version 14.0.2

* FIX: fixed a problem with refunds introduced in version 14.0.0.

2021.01.18 - version 14.0.1

* FIX: Removed a debug line in Global Class which caused a fatal error. 

2020.01.14 - version 14.0.0

* NEW: Added compatibility with Yith WooCommerce Subscriptions Premium.
* NEW: Added WooCommerce Add Payment Method feature.
* NEW: Added the ability to see all user tokens from the User Edit administration page.
* NEW: Added TRA SCA with a max price. WARNING: Your bank has to activate it in your terminal.
* NEW: The receipt page has been removed from Redsys (by Jose Conti) so after press the Pay button, the customer directly arrives at Redsys. This functionality will be added to the other forms of payment throughout future versions.
* NEW: Now the plugin deactivates other Redsys Plugins on activation. It causes too many problems that other Redsys plugins are active, and many people do not read the warnings or instructions.
* NEW: Added more checks to mark renewal subscriptions as paid. For some reason, Redsys does not always respond via Webservice even if the renewal is done correctly.
* FIX: Fixed a problem with BIZUM where the orders have not been marked as paid in test mode.
* FIX: Problem with TXNID.
* Declared compatibility with WooCommerce 4.9
* Fixed a problem with Preauthorization Logs

2020.12.28 - version 13.0.0

* Full compatibility with PSD2.
* Declared compatibility with WordPress 5.6
* Full translation to Spanish. Thanks to Fernando Tellado https://twitter.com/fernandot


2020.12.06 - version 12.2.0

* Added compatibility Bulk charge Invoices with PSD2.
* Declared compatibility with WooCommerce 4.8

2020.12.04 - version 12.1.1

* Fixed a problem with subscription renewal under PDS2.

2020.11.30 - version 12.1.0

* NEW: Added official InSite plugin to Health Check.
* NEW: Added a warning if WooCommerce is not connected to WooCommerce.com.
* NEW: Added date, hour, Commerce name, and FUC to the thank you page.
* NEW: Added a Redsys meta tab to the product edit page with options. Now you can get a Token for some products. 

2020.11.14 - version 12.0.3

* Removed ghost button at the receipt page when is Browser iFrame.
* Fixed a problem related to Tokenization and Pay with 1 clic.

2020.11.11 - version 12.0.2

* Extended explanations in Health Site to better explain the problems that cause the errors.
* Fixed a bug in Credit card Widget with "height"
* Fixed a problem related to receip page
* Fixed a problem related to Subscriptions
* Fixed a problem related to old tokens and PSD2
* Declared compatibility with WooCommerce 4.7

2020.11.10 - version 12.0.1

* Fixed a problem with PSD2 when a user has never bought in the store.
* Fixed a strange problem in some servers where there is a 500 server error in the notification end-point.
* Fixed a problem with an array() in logs.
* Updated a variable name from capital letters to lowercase

2020.11.06 - version 12.0.0

* NEW: Now is PSD2 Ready. Check Redsys (by Jose Conti) settings.
* NEW: Added items to Site Health.
* Redsys Browser iframe. Check Redsys (by Jose Conti) settings.
* Declared compatibility with WooCommerce 4.6


2020.08.06 - version 9.4.0

* NEW: Now you can select what to show in Redsys Description
* NEW: Added a very big Notice Warning when other Redsys plugin is in use.
* Declared compatibility with WooCommerce 4.4

2020.07.24 - version 9.3.0

* Added new languages
* Added more priority to WCRed() function

2020.07.16 - version 9.2.3

* Fixed InSite.

2020.07.13 - version 9.2.2

* Fixed Charge Orders Bulk Action.

2020.07.12 - version 9.2.1

* Fixed all Bulk Actions.
* Removed many notices, included in Redsys API files.
* Fixed a Ghost column when Invoices is active.
* Updated po/mo files

2020.07.09 - version 9.2.0

* NEW: Now there is a Gateway for Direct Debit so you can use plugins for Gateway Logic for use it.
* NEW: Now you can customize the button text at the checkout by Gateway
* NEW: Now you can customize the button colors at the checkout by Gateway
* NEW: Added Redsys authorization number to Thank you page. Activate from Redsys (by Jose Conti)
* Removed dimisible Scripts
* Fixed: Missing default inSite Logo at the checkout
* Fixed: Fatal error at Redsys Endpoint when Subscriptions don't save token is active.
* Fixed: Fixed an error with MasterPass End Point.
* Fixed: authorize preauthorizartions error if Redsys (by Jose Conti) is empty.
* Fixed: Many annotations in preauthorizations order.
* Fixed: Compatibility with Custom User Registration Fields for WooCommerce
* Declared compatibility with WooCommerce 4.3
* Updated po/mo files

2020.06.10 - version 9.1.1

* Fixed: Forgot to add InSite file.

2020.06.09 - version 9.1.0

* NEW: Added InSite

2020.06.02 - version 9.0.2

* Improved Tokens Check

2020.05.31 - version 9.0.1

* Improved notice in the Checkout about Gateways in Test Mode.
* Fixed a problem with Webservice. A deprecated field was causing errors with the signature.


2020.05.25 - version 9.0.0

* NEW: Added Redsys Bank Transfer
* NEW: Added Checkout Notice for know when a Gateway is in Test Mode
* Updated where to find Gateways Logs

2020.05.22 - version 8.0.0

* NEW: Added exclusive gateway for pre-authorizations through Redsys.
* NEW: Now the customer name is sent to Redsys.
* Added more functions to WooCommerce Redsys Gateway API.
* Fixed an error with language selections at MasterPass settings.
* Fixed a notice that caused a header already send.

2020.04.23 - version 7.1.0

* NEW: Added bulk Refund action.
* Fixed problem approving pre-authorization at some servers.

2020.04.22 - version 7.0.2

* Fixed error at product screen > Private Product tab.
* Fixed including email file.

2020.04.21 - version 7.0.1

* Fixed ALL Official Redsys API Files. The oficial API files there were causing header already sent

2020.04.21 - version 7.0.0

* NEW: Added MasterPass
* New check of tokens. Before use a token, the plugin check if it is a Redsys token (specially for Subscriptions).
* New Year/Date token check before use it. Now, the plugin check if the Token is currently active, if it is not active, the Token is removed and a new token is requested.
* Now you can disable tokenization for WooCommerce Subscriptions. Tokenization is enabled by default (Enable Pay with One Click is not needed).
* Now, all Payment methods are in WooCommerce Gateways list.
* Refactoring allowed currencies check.
* Added more languages support
* Removed Orders Export.
* General refactoring code & adding tools for developers with magic global function WCRed()
* Date, hour, auth Data unification in order admin page.
* Removed iUpay
* Declared compatibility with WooCommerce 4.0
* Declared compatibility with WordPress 5.4

2020.02.07 - version 6.1.0

* NEW: Refunds Bizum
* NEW: Test mode by User (Bizum).
* NEW: Test SHA256 at settings (Credit card & Bizum)
* Improvement: Now you don't have to activate 1-click payment to get the token if the order is a subscription.
* Improvement: Better update notice.
* Fixed: Now a log is not saved that was saved even if the Redsys log was not activated.


2020.01.01 - version 6.0.0

* NEW: Added Bizum
* NEW: Added compatibility with WooCommerce Deposits.
* Fixed a problema with Redsys Credit Card Image Widget. It was inadvertently removed in the previous version.
* Now ALL Webservice connections are forced without verification.
* Now, all new tokens are forced as default,

2019.11.06 - version 5.4.5

* Added more debug code.
* Updated some deprecated subscriptions functions.

2019.11.05 - version 5.4.4.1

* Refactoring

2019.11.05 - version 5.4.4

* Fixed a bug inherited by a refactoring whereby currencies were not loaded correctly.
* Fixed a typo in a sanitization function

2019.10.30 - version 5.4.3

* Fixed a bug where the invoice numbers were not shown in the order list.
* Added a check on the than you page in case someone arrives directly without being redirected by an order.
* Fixed a bug where if there was a user in the list of user test mode, that user always used the gateway in test mode even if the test mode was not activated.
* I have eliminated the possibility for users to change their payment method, as WooCommerce charges the subscription fee again. I will look for a way that does not charge anything.
* Improved the design of the administration notice about updates.

2019.10.15 - version 5.4.2

* Fixed a strange problem where in some shops a development filter was loaded and caused the thankyou page to go blank.

2019.10.14 - version 5.4.1

* I've hidden the option of adding payment methods through Redsys because I didn't get a valid solution from the developers of WooCommerce.
* I have fixed the problem with 0 amount payments when there is a user token.

2019.10.07 - version 5.4.0

* NEW: Added test mode for specific users.
* NEW: Added a Widget for Credit cards.
* NEW; Now, when a subscription fails, scheduled woocommerce_scheduled_subscription_payment_retry is created.
* NEW: If there is a problem renewing a subscription, an email is now sent to the site administrator.
* NEW: Added Order comments with the error when there is a problem renewing a subscription 
* Added a separate file for currencies.
* Added more debug lines
* Fixed the double email by Subscription renewal.

2019.09.18 - version 5.3.1

* NEW: Added Fake data when Redsys doesn't send some fields.
* Fixed a rare problem with Subscription renewals.

2019.09.11 - version 5.3.0

* NEW: Added Redsys Bulk Action: "Approve Pre-authorization".

2019.09.09 - version 5.2.0

* NEW: Added Redsys Bulk Action: "Immediate Redsys Charge".
* Fixed a string.

2019.09.06 - version 5.1.3

* NEW: Added a notice linking to PSD2 / SCA. Post.
* NEW: Added +230 new currencies supported by Redsys.

2019.08.25 - version 5.1.2

* Fixed a problem when the when the price is less than 1

2019.07.23 - version 5.1.1

* Fixed a Notice in the dashboard

2019.07.22 - version 5.1.0

* NEW: Added a Check at Thank you page. If a customer arrive to Thank you page, and the order has not been market as paid, and email is send to administrator. Go to settings for activate it and/or modify text.
* Added many index.php
* NEW: Added a notification to explain all the improvements that have been made in the new version.

2019.07.15 - version 5.0.1

* Fixed a problem with redirection related to new Subscription feature.
* Refactoring

2019.07.15 - version 5.0.0

* NEW: Added compatibility with WooCommerce Subscriptions

2019.07.12 - version 4.7.0

* NEW: Payment with 1 click without leaving the website
* NEW: Now the plugin recognizes new credit cards added by Redsys.
* More debug information

2019.03.07 - version 4.6.2

* Fixed a random problem with some themes related to a redirection option

2019.03.04 - version 4.6.1.1

* Fixed dismissible admin_notices

2019.03.04 - version 4.6.1

* NEW: Added a notice in the WordPress Dashboard for remember that you can contact if there is a problem with the plugin.
* Fixed Translation strings.
* Updated mo/po files

2019.03.04 - version 4.6.0

* NEW: Now you can enable an email to be sent to the customer when he has a problem paying at Redsys. This helps the recovery of abandoned carts due to customer frustration with payment.
* NEW: Added a filter to modify email text.
* NEW: Added a link to make a twit if you like the plugin.
* Fixed some notices.
* Updated deprecated function.
* Updated mo/po files

2019.02.25 - version 4.5.1

* Now you can select what to do after payment. Mark as Processing (WooCommerce Default) or Mark as Complete.

2019.01.15 - version 4.5.0

* NEW: Added currency Redsys Code to filter
* NEW: Added more info to emails when a customer has a problem in Redsys.
* NEW: Added email when Pay with one click (Tokenization) is active but Redsys is not sending all needed data in the callback.
* NEW: Now SHA256, currency and terminal are saved as Order Metadata.
* NEW: Added 3 helpful support link in Redsys Settings (Plugin documentation, FAQ & Open a Ticket)

2018.06.22 - version 4.4.1

* Fixed a multiform on order-pay
* Fixed a problem with Microsoft Edge Browser, in some cases, Redsys can respond with order already send.

2018.06.18 - version 4.4.0

* NEW: Added a filter for modify Redsys valors from a third plugins or Theme.
* Fixed a problem with the redirection to Redsys with some Chrome versions.

2018.05.14 - version 4.3.0

* NEW: Added Type of payment Dropdown.
* NEW: Added Direct Debit payment
* NEW: Added Private Products
* updated po/mo

2018.05.10 - version 4.2.0

* WANRNING: Renamed main file (New WooCommerce Marked Place requeriment). YOU WILL NEED TO REACTIVATE THE PLUGIN
* NEW: Added Preauthorizations.
* NEW: Added Approve preauthorization from orders page.
* NEW: Added option for redirect to checkout after add a product to the cart.
* Updated po/mo.
* Fixed Notice: prueba not defined.
* Added Woo header

2018.03.09 - version 4.1.0

* NEW: Added ability to send emails when a payment fails with information about the payment errors. Check extension setting.
* Updated po/mo

2018.03.05 - version 4.0.1

* Added more allowed currencies.
* Improved credit cards identification.
* Updated Headers extension
* Updated po/mo

2018.02.21 - version 4.0.0

* NEW: Added refund.
* NEW: Added Tokenization (Pay with 1 click).
* NEW: Added ability for customize checkout logo.
* NEW: Added Redsys API for PHP 7.x
* Updated deprecated code.

2017.02.20 - version 3.2.0

* NEW: Added compatibility with SNI Certificates (ex: Let's Encrypt). You need to activate SNI compatibility in Redsys Settings.

2016.02.17 - version 3.1.1

* Fixed language selection
* Removing obsolete SHA-1 code
* Fixed Iupay message
* Updated some messages
* Updated language files

2015.11.03 - version 3.0.0

* NEW: Added new SHA-256 API to Redsys.
* NEW: Added new SHA-256 API to Iupay.
* NEW: Added check for if the admin added the new secret SHA-256 Redsys settings.
* NEW: Added check for if the admin added the new secret SHA-256 for Iupay settings.
* NEW: Added Check for mcrypt_encrypt needed for the new SHA-256 API.
* Updated translation files.

2015.08.05 - Version 2.1.0

* Fixed a bug in Sequential Invoice number.

2015.06.02 - Version 2.0.0

* NEW: Added Iupay!.
* NEW: Added Sequential Invoice number.
* NEW: Added Export Orders to CSV.
* Updated Redsys URL
* Fixed code for some test Banks.
* Added Ds_Merchant_MerchantName

2015.2.11 - version 1.9.0
* Added compatibility with WooCommerce 2.3

2014.08.08 - version 1.8.0
 * Added some meta to Orders
 * Ds_AuthorisationCode
 * Ds_Date
 * Ds_Hour
 * Ds_AuthorisationCode
 * Ds_Card_Country

2014.06.21 - version 1.7.0
 * NEW: Added compatibility with WPML. Now, the Redsys Gateway is shown in the customer language if WPML is installed.

2014.06.15 - version 1.6.0
 * NEW: Added compatibility with "WooCommerce Sequential Order Numbers Pro"

2014.05.06 - version 1.5.1
 * Fixed Terminal number.

2014.04.30 - version 1.5.0
 * NEW: Added ability for select the language for Redsys Gateway from admin panel.
 * NEW: Added a Second Terminal, now the Admins can set a second terminal.
 * Fixed a problem with shops under HTTPS

2014.04.23 - version 1.4.0
 * Fixed return url when the payment fails

2014.01.10 - version 1.3.0
 * Compatibility fix with WooCommerce 2.1

2013.10.09 - version 1.2.0
 * Fix a posible problem with duplicated orders number and Redsys Gateway if the customer go back.

2013.06.25 - version 1.1.0
 * Fixed odd caracter
 * Added BRL currency

2013.03.21 - version 1.0.0
 * First Release
